diff --git a/src/vbox/vbox_tmpl.c b/src/vbox/vbox_tmpl.c
index 3208f03..0e829e3 100644
--- a/src/vbox/vbox_tmpl.c
+++ b/src/vbox/vbox_tmpl.c
@@ -1302,11 +1624,15 @@ static int vboxDomainSave(virDomainPtr dom, const char *path ATTRIBUTE_UNUSED) {
                 console->vtbl->SaveState(console, &progress);
 
                 if (progress) {
+#if VBOX_API_VERSION == 2002
                     nsresult resultCode;
+#else
+                    PRInt32 resultCode;
+#endif
 
                     progress->vtbl->WaitForCompletion(progress, -1);
                     progress->vtbl->GetResultCode(progress, &resultCode);
-                    if (NS_SUCCEEDED(rc)) {
+                    if (NS_SUCCEEDED(resultCode)) {
                         ret = 0;
                     }
                     progress->vtbl->nsisupports.Release((nsISupports *)progress);
@@ -1317,16 +1643,24 @@ static int vboxDomainSave(virDomainPtr dom, const char *path ATTRIBUTE_UNUSED) {
         }
 
         DEBUG("UUID of machine being saved:"
+#if VBOX_API_VERSION == 2002
               "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
               (unsigned)iid->m0,    (unsigned)iid->m1, (unsigned)iid->m2,
               (unsigned)iid->m3[0], (unsigned)iid->m3[1],
               (unsigned)iid->m3[2], (unsigned)iid->m3[3],
               (unsigned)iid->m3[4], (unsigned)iid->m3[5],
               (unsigned)iid->m3[6], (unsigned)iid->m3[7]);
+#else
+              "%s", iidUtf8);
+#endif
     }
 
+#if VBOX_API_VERSION == 2002
 cleanup:
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     return ret;
 }
 
@@ -1335,14 +1669,21 @@ static char *vboxDomainDumpXML(virDomainPtr dom, int flags) {
     vboxGlobalData *data = dom->conn->privateData;
     virDomainDefPtr def  = NULL;
     IMachine *machine    = NULL;
-    nsID *iid            = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     char *ret            = NULL;
     int gotAllABoutDef   = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if (VIR_ALLOC(def) < 0) {
         virReportOOMError(dom->conn);
@@ -1350,9 +1691,15 @@ static char *vboxDomainDumpXML(virDomainPtr dom, int flags) {
     }
 
     if(data->vboxObj) {
-        nsIDFromChar(iid, dom->uuid);
 
+#if VBOX_API_VERSION == 2002
+        nsIDFromChar(iid, dom->uuid);
         rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iid, &machine);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+        rc = data->vboxObj->vtbl->GetMachine(data->vboxObj, iidUtf16, &machine);
+#endif
         if (NS_SUCCEEDED(rc) && machine) {
             PRBool accessible = PR_FALSE;
 
@@ -2220,7 +2567,11 @@ static char *vboxDomainDumpXML(virDomainPtr dom, int flags) {
         ret = virDomainDefFormat(dom->conn, def, flags);
 
 cleanup:
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     virDomainDefFree(def);
     return ret;
 }
@@ -2257,7 +2608,13 @@ static int vboxListDefinedDomains(virConnectPtr conn, char ** const names, int m
                 machine->vtbl->GetAccessible(machine, &isAccessible);
                 if (isAccessible) {
                     machine->vtbl->GetState(machine, &state);
-                    if ((state != MachineState_Running) &&
+                    if ((state != MachineState_Starting)   &&
+                        (state != MachineState_Running)    &&
+                        (state != MachineState_Stuck)      &&
+                        (state != MachineState_Stopping)   &&
+                        (state != MachineState_Saving)     &&
+                        (state != MachineState_Restoring)  &&
+                        (state != MachineState_Discarding) &&
                         (state != MachineState_Paused) ) {
                         machine->vtbl->GetName(machine, &machineNameUtf16);
                         data->pFuncs->pfnUtf16ToUtf8(machineNameUtf16, &machineName);
@@ -2316,7 +2673,13 @@ static int vboxNumOfDefinedDomains(virConnectPtr conn) {
                 machine->vtbl->GetAccessible(machine, &isAccessible);
                 if (isAccessible) {
                     machine->vtbl->GetState(machine, &state);
-                    if ((state != MachineState_Running) &&
+                    if ((state != MachineState_Starting)   &&
+                        (state != MachineState_Running)    &&
+                        (state != MachineState_Stuck)      &&
+                        (state != MachineState_Stopping)   &&
+                        (state != MachineState_Saving)     &&
+                        (state != MachineState_Restoring)  &&
+                        (state != MachineState_Discarding) &&
                         (state != MachineState_Paused) ) {
                         ret++;
                     }
@@ -2369,12 +2732,23 @@ static int vboxDomainCreate(virDomainPtr dom) {
 
             machine->vtbl->GetAccessible(machine, &isAccessible);
             if (isAccessible) {
+#if VBOX_API_VERSION == 2002
                 nsID *iid = NULL;
 
                 machine->vtbl->GetId(machine, &iid);
                 if (!iid)
                     continue;
                 nsIDtoChar(iidl, iid);
+#else
+                PRUnichar *iidUtf16 = NULL;
+                char      *iidUtf8  = NULL;
+
+                machine->vtbl->GetId(machine, &iidUtf16);
+                if (!iidUtf16)
+                    continue;
+                data->pFuncs->pfnUtf16ToUtf8(iidUtf16, &iidUtf8);
+                virUUIDParse(iidUtf8, iidl);
+#endif
 
                 if (memcmp(dom->uuid, iidl, VIR_UUID_BUFLEN) == 0) {
                     PRUint32 state = MachineState_Null;
@@ -2486,7 +2860,11 @@ static int vboxDomainCreate(virDomainPtr dom) {
 
                         data->vboxObj->vtbl->OpenRemoteSession(data->vboxObj,
                                                                data->vboxSession,
+#if VBOX_API_VERSION == 2002
                                                                iid,
+#else
+                                                               iidUtf16,
+#endif
                                                                sessionType,
                                                                env,
                                                                &progress );
@@ -2496,7 +2874,11 @@ static int vboxDomainCreate(virDomainPtr dom) {
                             ret = -1;
                         } else {
                             PRBool completed = 0;
+#if VBOX_API_VERSION == 2002
                             nsresult resultCode;
+#else
+                            PRInt32  resultCode;
+#endif
                             progress->vtbl->WaitForCompletion(progress, -1);
                             rc = progress->vtbl->GetCompleted(progress, &completed);
                             if (NS_FAILED(rc)) {
@@ -2527,8 +2909,12 @@ static int vboxDomainCreate(virDomainPtr dom) {
                     }
                 }
 
-                if (iid)
-                    data->pFuncs->pfnComUnallocMem(iid);
+#if VBOX_API_VERSION == 2002
+                data->pFuncs->pfnComUnallocMem(iid);
+#else
+                data->pFuncs->pfnUtf8Free(iidUtf8);
+                data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
                 if (ret != -1)
                     break;
             }
@@ -2550,13 +2936,19 @@ cleanup:
 
 static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
     nsresult rc;
-    vboxGlobalData *data = conn->privateData;
-    IMachine *machine   = NULL;
-    IBIOSSettings *bios = NULL;
-    virDomainPtr dom    = NULL;
-    nsID *iid           = NULL;
-    nsID *mchiid        = NULL;
-    virDomainDefPtr def = NULL;
+    vboxGlobalData *data        = conn->privateData;
+    IMachine *machine           = NULL;
+    IBIOSSettings *bios         = NULL;
+    virDomainPtr dom            = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid                  = NULL;
+    nsID *mchiid                = NULL;
+#else
+    PRUnichar *iidUtf16         = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+    PRUnichar *mchiidUtf16      = NULL;
+#endif
+    virDomainDefPtr def         = NULL;
     PRUnichar *machineNameUtf16 = NULL;
 
     if (!(def = virDomainDefParseString(conn, data->caps, xml,
@@ -2564,19 +2956,30 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
         goto cleanup;
     }
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(conn);
         goto cleanup;
     }
+#endif
 
     if (data->vboxObj) {
         data->pFuncs->pfnUtf8ToUtf16(def->name, &machineNameUtf16);
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, def->uuid);
+#else
+        virUUIDFormat(def->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+#endif
         rc = data->vboxObj->vtbl->CreateMachine(data->vboxObj,
                                                 machineNameUtf16,
                                                 NULL,
                                                 NULL,
+#if VBOX_API_VERSION == 2002
                                                 iid,
+#else
+                                                iidUtf16,
+#endif
                                                 &machine);
         data->pFuncs->pfnUtf16Free(machineNameUtf16);
 
@@ -2642,8 +3045,13 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
          * object so open a session to it and get it back, so that
          * you can make changes to the machine setting
          */
+#if VBOX_API_VERSION == 2002
         machine->vtbl->GetId(machine, &mchiid);
         data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, mchiid);
+#else
+        machine->vtbl->GetId(machine, &mchiidUtf16);
+        data->vboxObj->vtbl->OpenSession(data->vboxObj, data->vboxSession, mchiidUtf16);
+#endif
         data->vboxSession->vtbl->GetMachine(data->vboxSession, &machine);
 
         {   /* Started:Block to set the boot device order */
@@ -2726,44 +3134,74 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
 
                             machine->vtbl->GetDVDDrive(machine, &dvdDrive);
                             if (dvdDrive) {
-                                IDVDImage *dvdImage     = NULL;
-                                PRUnichar *dvdfileUtf16 = NULL;
-                                nsID *dvduuid           = NULL;
+                                IDVDImage *dvdImage          = NULL;
+                                PRUnichar *dvdfileUtf16      = NULL;
+#if VBOX_API_VERSION == 2002
+                                nsID *dvduuid                = NULL;
                                 nsID dvdemptyuuid;
 
                                 memset(&dvdemptyuuid, 0, sizeof(dvdemptyuuid));
+#else
+                                char      *dvduuidUtf8       = NULL;
+                                PRUnichar *dvduuidUtf16      = NULL;
+                                PRUnichar *dvdemptyuuidUtf16 = NULL;
+#endif
 
                                 data->pFuncs->pfnUtf8ToUtf16(def->disks[i]->src, &dvdfileUtf16);
 
                                 data->vboxObj->vtbl->FindDVDImage(data->vboxObj, dvdfileUtf16, &dvdImage);
                                 if (!dvdImage) {
+#if VBOX_API_VERSION == 2002
                                     data->vboxObj->vtbl->OpenDVDImage(data->vboxObj, dvdfileUtf16, &dvdemptyuuid, &dvdImage);
+#else
+                                    data->vboxObj->vtbl->OpenDVDImage(data->vboxObj, dvdfileUtf16, dvdemptyuuidUtf16, &dvdImage);
+#endif
                                 }
                                 if (dvdImage) {
+#if VBOX_API_VERSION == 2002
                                     rc = dvdImage->vtbl->imedium.GetId((IMedium *)dvdImage, &dvduuid);
+#else
+                                    rc = dvdImage->vtbl->imedium.GetId((IMedium *)dvdImage, &dvduuidUtf16);
+#endif
                                     if (NS_FAILED(rc)) {
                                         vboxError(conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                   "can't get the uuid of the file to be attached to cdrom",
                                                   def->disks[i]->src, (unsigned)rc);
                                     } else {
+#if VBOX_API_VERSION == 2002
                                         rc = dvdDrive->vtbl->MountImage(dvdDrive, dvduuid);
+#else
+                                        rc = dvdDrive->vtbl->MountImage(dvdDrive, dvduuidUtf16);
+#endif
                                         if (NS_FAILED(rc)) {
                                             vboxError(conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                       "could not attach the file to cdrom",
                                                       def->disks[i]->src, (unsigned)rc);
                                         } else {
-                                            DEBUG("CD/DVDImage UUID:{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
-                                            (unsigned)dvduuid->m0,    (unsigned)dvduuid->m1, (unsigned)dvduuid->m2,
-                                            (unsigned)dvduuid->m3[0], (unsigned)dvduuid->m3[1],
-                                            (unsigned)dvduuid->m3[2], (unsigned)dvduuid->m3[3],
-                                            (unsigned)dvduuid->m3[4], (unsigned)dvduuid->m3[5],
-                                            (unsigned)dvduuid->m3[6], (unsigned)dvduuid->m3[7]);
+#if VBOX_API_VERSION == 2002
+                                            DEBUG("CD/DVDImage UUID:"
+                                                  "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
+                                                  (unsigned)dvduuid->m0,    (unsigned)dvduuid->m1,
+                                                  (unsigned)dvduuid->m2,    (unsigned)dvduuid->m3[0],
+                                                  (unsigned)dvduuid->m3[1], (unsigned)dvduuid->m3[2],
+                                                  (unsigned)dvduuid->m3[3], (unsigned)dvduuid->m3[4],
+                                                  (unsigned)dvduuid->m3[5], (unsigned)dvduuid->m3[6],
+                                                  (unsigned)dvduuid->m3[7]);
+#else
+                                            data->pFuncs->pfnUtf16ToUtf8(dvduuidUtf16, &dvduuidUtf8);
+                                            DEBUG("CD/DVDImage UUID: %s", dvduuidUtf8);
+                                            data->pFuncs->pfnUtf8Free(dvduuidUtf8);
+#endif
                                         }
-                                        data->pFuncs->pfnComUnallocMem(dvduuid);
                                     }
 
                                     dvdImage->vtbl->imedium.nsisupports.Release((nsISupports *)dvdImage);
                                 }
+#if VBOX_API_VERSION == 2002
+                                data->pFuncs->pfnComUnallocMem(dvduuid);
+#else
+                                data->pFuncs->pfnUtf16Free(dvduuidUtf16);
+#endif
                                 data->pFuncs->pfnUtf16Free(dvdfileUtf16);
                                 dvdDrive->vtbl->nsisupports.Release((nsISupports *)dvdDrive);
                             }
@@ -2773,10 +3211,15 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
                         if (def->disks[i]->type == VIR_DOMAIN_DISK_TYPE_FILE) {
                             IHardDisk *hardDisk     = NULL;
                             PRUnichar *hddfileUtf16 = NULL;
+#if VBOX_API_VERSION == 2002
                             nsID *hdduuid           = NULL;
+#else
+                            PRUnichar *hdduuidUtf16 = NULL;
+                            char      *hdduuidUtf8  = NULL;
+#endif
                             /* Current Limitation: Harddisk can't be connected to
                              * Secondary Master as Secondary Master is always used
-                             * for CD/DVD Drive, so not connect the harddisk if it
+                             * for CD/DVD Drive, so don't connect the harddisk if it
                              * is requested to be connected to Secondary master
                              */
 
@@ -2785,14 +3228,29 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
                             data->vboxObj->vtbl->FindHardDisk(data->vboxObj, hddfileUtf16, &hardDisk);
 
                             if (!hardDisk) {
+#if VBOX_API_VERSION == 2002
+                                data->vboxObj->vtbl->OpenHardDisk(data->vboxObj,
+                                                                  hddfileUtf16,
+                                                                  AccessMode_ReadWrite,
+                                                                  &hardDisk);
+#else
                                 data->vboxObj->vtbl->OpenHardDisk(data->vboxObj,
                                                                   hddfileUtf16,
                                                                   AccessMode_ReadWrite,
+                                                                  0,
+                                                                  NULL,
+                                                                  0,
+                                                                  NULL,
                                                                   &hardDisk);
+#endif
                             }
 
                             if (hardDisk) {
+#if VBOX_API_VERSION == 2002
                                 rc = hardDisk->vtbl->imedium.GetId((IMedium *)hardDisk, &hdduuid);
+#else
+                                rc = hardDisk->vtbl->imedium.GetId((IMedium *)hardDisk, &hdduuidUtf16);
+#endif
                                 if (NS_FAILED(rc)) {
                                     vboxError(conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                               "can't get the uuid of the file to be attached as harddisk",
@@ -2829,9 +3287,15 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
                                                 device  = 1;
                                             }
 
-                                            rc = machine->vtbl->AttachHardDisk(machine, hdduuid,
+                                            rc = machine->vtbl->AttachHardDisk(machine,
+#if VBOX_API_VERSION == 2002
+                                                                               hdduuid,
+#else
+                                                                               hdduuidUtf16,
+#endif
                                                                                hddcnameUtf16,
-                                                                               channel, device);
+                                                                               channel,
+                                                                               device);
                                             data->pFuncs->pfnUtf16Free(hddcnameUtf16);
 
                                             if (NS_FAILED(rc)) {
@@ -2839,21 +3303,31 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
                                                           "could not attach the file as harddisk",
                                                           def->disks[i]->src, (unsigned)rc);
                                             } else {
+#if VBOX_API_VERSION == 2002
                                                 DEBUG("Attached HDD with UUID:"
                                                       "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
-                                                (unsigned)hdduuid->m0,    (unsigned)hdduuid->m1,
-                                                (unsigned)hdduuid->m2,
-                                                (unsigned)hdduuid->m3[0], (unsigned)hdduuid->m3[1],
-                                                (unsigned)hdduuid->m3[2], (unsigned)hdduuid->m3[3],
-                                                (unsigned)hdduuid->m3[4], (unsigned)hdduuid->m3[5],
-                                                (unsigned)hdduuid->m3[6], (unsigned)hdduuid->m3[7]);
+                                                      (unsigned)hdduuid->m0,    (unsigned)hdduuid->m1,
+                                                      (unsigned)hdduuid->m2,    (unsigned)hdduuid->m3[0],
+                                                      (unsigned)hdduuid->m3[1], (unsigned)hdduuid->m3[2],
+                                                      (unsigned)hdduuid->m3[3], (unsigned)hdduuid->m3[4],
+                                                      (unsigned)hdduuid->m3[5], (unsigned)hdduuid->m3[6],
+                                                      (unsigned)hdduuid->m3[7]);
+#else
+                                                data->pFuncs->pfnUtf16ToUtf8(hdduuidUtf16, &hdduuidUtf8);
+                                                DEBUG("Attached HDD with UUID: %s", hdduuidUtf8);
+                                                data->pFuncs->pfnUtf8Free(hdduuidUtf8);
+#endif
                                             }
                                         }
                                     }
-                                    data->pFuncs->pfnComUnallocMem(hdduuid);
                                 }
                                 hardDisk->vtbl->imedium.nsisupports.Release((nsISupports *)hardDisk);
                             }
+#if VBOX_API_VERSION == 2002
+                            data->pFuncs->pfnComUnallocMem(hdduuid);
+#else
+                            data->pFuncs->pfnUtf16Free(hdduuidUtf16);
+#endif
                             data->pFuncs->pfnUtf16Free(hddfileUtf16);
                         } else if (def->disks[i]->type == VIR_DOMAIN_DISK_TYPE_BLOCK) {
                         }
@@ -2864,48 +3338,79 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
                             if (floppyDrive) {
                                 rc = floppyDrive->vtbl->SetEnabled(floppyDrive, 1);
                                 if (NS_SUCCEEDED(rc)) {
-                                    IFloppyImage *floppyImage = NULL;
-                                    PRUnichar *fdfileUtf16    = NULL;
-                                    nsID *fduuid              = NULL;
+                                    IFloppyImage *floppyImage   = NULL;
+                                    PRUnichar *fdfileUtf16      = NULL;
+#if VBOX_API_VERSION == 2002
+                                    nsID *fduuid                = NULL;
                                     nsID fdemptyuuid;
 
                                     memset(&fdemptyuuid, 0, sizeof(fdemptyuuid));
+#else
+                                    char      *fduuidUtf8       = NULL;
+                                    PRUnichar *fduuidUtf16      = NULL;
+                                    PRUnichar *fdemptyuuidUtf16 = NULL;
+#endif
 
                                     data->pFuncs->pfnUtf8ToUtf16(def->disks[i]->src, &fdfileUtf16);
-                                    rc = data->vboxObj->vtbl->FindFloppyImage(data->vboxObj, fdfileUtf16,
+                                    rc = data->vboxObj->vtbl->FindFloppyImage(data->vboxObj,
+                                                                              fdfileUtf16,
                                                                               &floppyImage);
 
                                     if (!floppyImage) {
-                                        data->vboxObj->vtbl->OpenFloppyImage(data->vboxObj, fdfileUtf16,
-                                                                             &fdemptyuuid, &floppyImage);
+                                        data->vboxObj->vtbl->OpenFloppyImage(data->vboxObj,
+                                                                             fdfileUtf16,
+#if VBOX_API_VERSION == 2002
+                                                                             &fdemptyuuid,
+#else
+                                                                             fdemptyuuidUtf16,
+#endif
+                                                                             &floppyImage);
                                     }
 
                                     if (floppyImage) {
+#if VBOX_API_VERSION == 2002
                                         rc = floppyImage->vtbl->imedium.GetId((IMedium *)floppyImage, &fduuid);
+#else
+                                        rc = floppyImage->vtbl->imedium.GetId((IMedium *)floppyImage, &fduuidUtf16);
+#endif
                                         if (NS_FAILED(rc)) {
                                             vboxError(conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                       "can't get the uuid of the file to be attached to floppy drive",
                                                       def->disks[i]->src, (unsigned)rc);
                                         } else {
+#if VBOX_API_VERSION == 2002
                                             rc = floppyDrive->vtbl->MountImage(floppyDrive, fduuid);
+#else
+                                            rc = floppyDrive->vtbl->MountImage(floppyDrive, fduuidUtf16);
+#endif
                                             if (NS_FAILED(rc)) {
                                                 vboxError(conn, VIR_ERR_INTERNAL_ERROR,"%s:%s, rc=%08x",
                                                           "could not attach the file to floppy drive",
                                                           def->disks[i]->src, (unsigned)rc);
                                             } else {
+#if VBOX_API_VERSION == 2002
                                                 DEBUG("floppyImage UUID:"
                                                       "{%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x}",
-                                                (unsigned)fduuid->m0,    (unsigned)fduuid->m1,
-                                                (unsigned)fduuid->m2,
-                                                (unsigned)fduuid->m3[0], (unsigned)fduuid->m3[1],
-                                                (unsigned)fduuid->m3[2], (unsigned)fduuid->m3[3],
-                                                (unsigned)fduuid->m3[4], (unsigned)fduuid->m3[5],
-                                                (unsigned)fduuid->m3[6], (unsigned)fduuid->m3[7]);
+                                                      (unsigned)fduuid->m0,    (unsigned)fduuid->m1,
+                                                      (unsigned)fduuid->m2,    (unsigned)fduuid->m3[0],
+                                                      (unsigned)fduuid->m3[1], (unsigned)fduuid->m3[2],
+                                                      (unsigned)fduuid->m3[3], (unsigned)fduuid->m3[4],
+                                                      (unsigned)fduuid->m3[5], (unsigned)fduuid->m3[6],
+                                                      (unsigned)fduuid->m3[7]);
+#else
+                                                data->pFuncs->pfnUtf16ToUtf8(fduuidUtf16, &fduuidUtf8);
+                                                DEBUG("floppyImage UUID: %s", fduuidUtf8);
+                                                data->pFuncs->pfnUtf8Free(fduuidUtf8);
+#endif
                                             }
-                                            data->pFuncs->pfnComUnallocMem(fduuid);
                                         }
                                         floppyImage->vtbl->imedium.nsisupports.Release((nsISupports *)floppyImage);
                                     }
+#if VBOX_API_VERSION == 2002
+                                    data->pFuncs->pfnComUnallocMem(fduuid);
+#else
+                                    data->pFuncs->pfnUtf16Free(fduuidUtf16);
+#endif
                                     data->pFuncs->pfnUtf16Free(fdfileUtf16);
                                 }
                                 floppyDrive->vtbl->nsisupports.Release((nsISupports *)floppyDrive);
@@ -2990,7 +3495,7 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
 
                 machine->vtbl->GetNetworkAdapter(machine, i, &adapter);
                 if (adapter) {
-                    PRUnichar *MACAddress      = NULL;
+                    PRUnichar *MACAddress = NULL;
 
                     adapter->vtbl->SetEnabled(adapter, 1);
 
@@ -3039,7 +3544,7 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
                         adapter->vtbl->AttachToHostOnlyInterface(adapter);
 
                         if (def->nets[i]->data.network.name) {
-                            g_pVBoxFuncs->pfnUtf8ToUtf16(def->nets[i]->data.network.name, &hostInterface);
+                            data->pFuncs->pfnUtf8ToUtf16(def->nets[i]->data.network.name, &hostInterface);
                             adapter->vtbl->SetHostInterface(adapter, hostInterface);
                             data->pFuncs->pfnUtf16Free(hostInterface);
                         }
@@ -3450,7 +3955,11 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
          */
         rc = machine->vtbl->SaveSettings(machine);
         data->vboxSession->vtbl->Close(data->vboxSession);
+#if VBOX_API_VERSION == 2002
         data->pFuncs->pfnComUnallocMem(mchiid);
+#else
+        data->pFuncs->pfnUtf16Free(mchiidUtf16);
+#endif
 
         dom = virGetDomain(conn, def->name, def->uuid);
         if(machine) {
@@ -3459,7 +3968,11 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
         }
     }
 
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     virDomainDefFree(def);
 
     return dom;
@@ -3467,7 +3980,11 @@ static virDomainPtr vboxDomainDefineXML(virConnectPtr conn, const char *xml) {
 cleanup:
     if(machine)
         machine->vtbl->nsisupports.Release((nsISupports *)machine);
+#if VBOX_API_VERSION == 2002
     VIR_FREE(iid);
+#else
+    data->pFuncs->pfnUtf16Free(iidUtf16);
+#endif
     virDomainDefFree(def);
     return NULL;
 }
@@ -3476,16 +3993,28 @@ static int vboxDomainUndefine(virDomainPtr dom) {
     nsresult rc;
     vboxGlobalData *data = dom->conn->privateData;
     IMachine *machine    = NULL;
-    nsID *iid            = NULL;
+#if VBOX_API_VERSION == 2002
+    nsID  *iid           = NULL;
+#else
+    PRUnichar *iidUtf16  = NULL;
+    char iidUtf8[VIR_UUID_STRING_BUFLEN];
+#endif
     int ret = -1;
 
+#if VBOX_API_VERSION == 2002
     if (VIR_ALLOC(iid) < 0) {
         virReportOOMError(dom->conn);
         goto cleanup;
     }
+#endif
 
     if(data->vboxObj) {
+#if VBOX_API_VERSION == 2002
         nsIDFromChar(iid, dom->uuid);
+#else
+        virUUIDFormat(dom->uuid, iidUtf8);
+        data->pFuncs->pfnUtf8ToUtf16(iidUtf8, &iidUtf16);
+#endif
 
         /* Block for checking if HDD's are attched to VM.
          * considering just IDE bus for now. Also skipped
